org.apache.ode.bpel.iapi

## Interface ProcessConf

- All Known Implementing Classes:
    ProcessConfImpl

      public interface ProcessConf

  Deployed process configuration. IMPORTANT: Implementations of this class MUST BE IMMUTABLE, otherwise the engine will get confused.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `ProcessConf.CLEANUP_CATEGORY`
    `static class` | `ProcessConf.CleanupInfo`
    `static class` | `ProcessConf.CronJob`
    `static class` | `ProcessConf.PartnerRoleConfig`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.net.URI` | `getBaseURI()` Get the base URL for resolving resources.
    `java.lang.String` | `getBpelDocument()` Get the path of the BPEL document, relative to its deployment unit
    `long` | `getCBPFileSize()` Get the CBP file size.
    `java.io.InputStream` | `getCBPInputStream()` Get the CBP stream.
    `java.util.Set<ProcessConf.CLEANUP_CATEGORY>` | `getCleanupCategories(boolean instanceSucceeded)`
    `java.util.List<ProcessConf.CronJob>` | `getCronJobs()`
    `javax.wsdl.Definition` | `getDefinitionForPortType(javax.xml.namespace.QName portTypeName)` Gets the WSDL definition used in a process into which a PortType is defined.
    `javax.wsdl.Definition` | `getDefinitionForService(javax.xml.namespace.QName serviceName)` Gets the WSDL definition used in a process into which a service is defined.
    `java.util.Date` | `getDeployDate()` Get the date of deployment.
    `java.lang.String` | `getDeployer()` Get the userid of the deployer.
    `java.util.Map<java.lang.String,java.lang.String>` | `getEndpointProperties(EndpointReference epr)`
    `java.util.List<org.w3c.dom.Element>` | `getExtensionElement(javax.xml.namespace.QName qname)` Generic facility to get additional stuff out of the process descriptor.
    `java.util.List<java.io.File>` | `getFiles()` Get the files associated with the deployment.
    `java.util.Map<java.lang.String,Endpoint>` | `getInvokeEndpoints()` Gets the list of endpoints a process invokes.
    `java.lang.String` | `getPackage()` Gets the name of the package into which the process is deployed.
    `java.util.Map<java.lang.String,ProcessConf.PartnerRoleConfig>` | `getPartnerRoleConfig()` Returns failure handling info for invokes.
    `javax.xml.namespace.QName` | `getProcessId()` Get the process id, generally the same as the type.
    `java.util.Map<javax.xml.namespace.QName,org.w3c.dom.Node>` | `getProcessProperties()` Get the process properties.
    `java.util.Map<java.lang.String,Endpoint>` | `getProvideEndpoints()` Gets the list of endpoints a process should provide.
    `ProcessState` | `getState()` Get the state of the process.
    `javax.xml.namespace.QName` | `getType()` Get the process type (BPEL definition name).
    `long` | `getVersion()` Get the process version.
    `boolean` | `isCleanupCategoryEnabled(boolean instanceSucceeded, ProcessConf.CLEANUP_CATEGORY category)`
    `boolean` | `isEventEnabled(java.util.List<java.lang.String> scopeNames, BpelEvent.TYPE type)`
    `boolean` | `isSharedService(javax.xml.namespace.QName serviceName)` Tells if the service is shareable
    `boolean` | `isTransient()` Is this a transient process? Transient processes are not persisted in the store.

- - ### Method Detail

    - #### getProcessId

          javax.xml.namespace.QName getProcessId()

      Get the process id, generally the same as the type.
      Returns:
        process id.

    - #### getType

          javax.xml.namespace.QName getType()

      Get the process type (BPEL definition name).
      Returns:

    - #### getVersion

          long getVersion()

      Get the process version.
      Returns:
        version

    - #### isTransient

          boolean isTransient()

      Is this a transient process? Transient processes are not persisted in the store.
      Returns:
        `true` if this is a transient process.

    - #### getCBPInputStream

          java.io.InputStream getCBPInputStream()

      Get the CBP stream.
      Returns:
        new stream to the CBP file.

    - #### getCBPFileSize

          long getCBPFileSize()

      Get the CBP file size.
      Returns:
        size of the CBP file.

    - #### getBpelDocument

          java.lang.String getBpelDocument()

      Get the path of the BPEL document, relative to its deployment unit
      Returns:
        Relative path of BPEL document

    - #### getBaseURI

          java.net.URI getBaseURI()

      Get the base URL for resolving resources.

    - #### getDeployDate

          java.util.Date getDeployDate()

      Get the date of deployment.
      Returns:

    - #### getDeployer

          java.lang.String getDeployer()

      Get the userid of the deployer.
      Returns:

    - #### getState

          ProcessState getState()

      Get the state of the process.
      Returns:
        process state.

    - #### getFiles

          java.util.List<java.io.File> getFiles()

      Get the files associated with the deployment.
      Returns:

    - #### getProcessProperties

          java.util.Map<javax.xml.namespace.QName,org.w3c.dom.Node> getProcessProperties()

      Get the process properties.
      Returns:

    - #### getPackage

          java.lang.String getPackage()

      Gets the name of the package into which the process is deployed.
      Returns:
        package name

    - #### getDefinitionForService

          javax.wsdl.Definition getDefinitionForService(javax.xml.namespace.QName serviceName)

      Gets the WSDL definition used in a process into which a service is defined.
      Parameters:
        `processId` -
        `serviceName` -
      Returns:
        definition

    - #### getDefinitionForPortType

          javax.wsdl.Definition getDefinitionForPortType(javax.xml.namespace.QName portTypeName)

      Gets the WSDL definition used in a process into which a PortType is defined.
      Parameters:
        `portTypeName` -
      Returns:
        definition

    - #### getProvideEndpoints

          java.util.Map<java.lang.String,Endpoint> getProvideEndpoints()

      Gets the list of endpoints a process should provide.
      Parameters:
        `processId` -
      Returns:
        map of partner link names and associated enpoints

    - #### getInvokeEndpoints

          java.util.Map<java.lang.String,Endpoint> getInvokeEndpoints()

      Gets the list of endpoints a process invokes.
      Parameters:
        `processId` -
      Returns:
        map of partner link names and associated enpoints

    - #### getPartnerRoleConfig

          java.util.Map<java.lang.String,ProcessConf.PartnerRoleConfig> getPartnerRoleConfig()

      Returns failure handling info for invokes.
      Returns:

    - #### isSharedService

          boolean isSharedService(javax.xml.namespace.QName serviceName)

      Tells if the service is shareable
      Parameters:
        `serviceName` -
      Returns:
        true if the given service can be shared by processes

    - #### getExtensionElement

          java.util.List<org.w3c.dom.Element> getExtensionElement(javax.xml.namespace.QName qname)

      Generic facility to get additional stuff out of the process descriptor.
      Parameters:
        `qname` - name of the extension element.
      Returns:
        list of extension elements

    - #### isEventEnabled

          boolean isEventEnabled(java.util.List<java.lang.String> scopeNames,
                                 BpelEvent.TYPE type)

    - #### getEndpointProperties

          java.util.Map<java.lang.String,java.lang.String> getEndpointProperties(EndpointReference epr)

    - #### isCleanupCategoryEnabled

          boolean isCleanupCategoryEnabled(boolean instanceSucceeded,
                                           ProcessConf.CLEANUP_CATEGORY category)

    - #### getCleanupCategories

          java.util.Set<ProcessConf.CLEANUP_CATEGORY> getCleanupCategories(boolean instanceSucceeded)

    - #### getCronJobs

          java.util.List<ProcessConf.CronJob> getCronJobs()